
/**
 * typed-contracts v0.1.1
 * Validation with good type inference (Flow support)
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('core-js/modules/es6.number.constructor');
require('core-js/modules/es6.number.is-nan');
require('core-js/modules/web.dom.iterable');
require('core-js/modules/es6.array.iterator');
require('core-js/modules/es6.object.keys');

function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _construct(Parent, args, Class) {
  if (isNativeReflectConstruct()) {
    _construct = Reflect.construct;
  } else {
    _construct = function _construct(Parent, args, Class) {
      var a = [null];
      a.push.apply(a, args);
      var Constructor = Function.bind.apply(Parent, a);
      var instance = new Constructor();
      if (Class) _setPrototypeOf(instance, Class.prototype);
      return instance;
    };
  }

  return _construct.apply(null, arguments);
}

function _wrapNativeSuper(Class) {
  var _cache = typeof Map === "function" ? new Map() : undefined;

  _wrapNativeSuper = function _wrapNativeSuper(Class) {
    if (Class === null) return null;

    if (typeof Class !== "function") {
      throw new TypeError("Super expression must either be null or a function");
    }

    if (typeof _cache !== "undefined") {
      if (_cache.has(Class)) return _cache.get(Class);

      _cache.set(Class, Wrapper);
    }

    function Wrapper() {
      return _construct(Class, arguments, _getPrototypeOf(this).constructor);
    }

    Wrapper.prototype = Object.create(Class.prototype, {
      constructor: {
        value: Wrapper,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    return _setPrototypeOf(Wrapper, Class);
  };

  return _wrapNativeSuper(Class);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  }
}

function _iterableToArray(iter) {
  if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance");
}

var valueToString = function valueToString(value) {
  if (Number.isNaN(value)) return 'NaN';

  switch (value) {
    case undefined:
      return 'undefined';

    case null:
      return 'null';

    default:
      return "".concat(JSON.stringify(value), " (").concat(_typeof(value), ")");
  }
};

var typesToString = function typesToString(expectedTypes) {
  return expectedTypes.slice(0, -2).concat(expectedTypes.slice(-2).join(' or ')).join(', ');
};

var ValidationError =
/*#__PURE__*/
function (_TypeError) {
  _inherits(ValidationError, _TypeError);

  _createClass(ValidationError, null, [{
    key: "of",
    value: function of(valueName, value, expectedType) {
      for (var _len = arguments.length, otherExpectedTypes = new Array(_len > 3 ? _len - 3 : 0), _key = 3; _key < _len; _key++) {
        otherExpectedTypes[_key - 3] = arguments[_key];
      }

      return _construct(ValidationError, [valueName, value, expectedType].concat(otherExpectedTypes));
    }
  }]);

  function ValidationError(valueName, value, expectedType) {
    var _this;

    _classCallCheck(this, ValidationError);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ValidationError).call(this));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "valueName", void 0);

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "expectedTypes", void 0);

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "value", void 0);

    _this.name = 'ValidationError';
    _this.valueName = valueName;
    _this.value = value;

    for (var _len2 = arguments.length, otherExpectedTypes = new Array(_len2 > 3 ? _len2 - 3 : 0), _key2 = 3; _key2 < _len2; _key2++) {
      otherExpectedTypes[_key2 - 3] = arguments[_key2];
    }

    _this.expectedTypes = [expectedType].concat(otherExpectedTypes);
    _this.message = "".concat(_this.valueName, " must be ").concat(typesToString(_this.expectedTypes), ", but ").concat(valueToString(value), " given");
    return _this;
  }

  return ValidationError;
}(_wrapNativeSuper(TypeError));

var createContract =
/* :: <T> */
function createContract(validate) {
  var maybe = function maybe(valueName, value) {
    return value == null ? value : validate(valueName, value);
  };

  var optional = function optional(valueName, value) {
    return value === undefined ? value : validate(valueName, value);
  };

  var contract = function contract(valueName, value) {
    return validate(valueName, value);
  };

  contract.maybe = maybe;
  contract.optional = optional;

  contract.bindName = function (valueName) {
    var named = function named(value) {
      return validate(valueName, value);
    };

    named.maybe = function (value) {
      return maybe(valueName, value);
    };

    named.optional = function (value) {
      return optional(valueName, value);
    };

    return named;
  };

  return contract;
};

var isArray = function isArray(contract) {
  return createContract(function (valueName, value) {
    if (!Array.isArray(value)) return ValidationError.of(valueName, value, 'Array');

    for (var index = 0; index < value.length; index += 1) {
      var result = contract("".concat(valueName, "[").concat(index, "]"), value[index]);
      if (result instanceof ValidationError) return result;
    }

    return value;
  });
};

var isLiteral = function isLiteral(expected) {
  return createContract(function (valueName, value) {
    if (value === expected) return value;
    return ValidationError.of(valueName, value, JSON.stringify(expected));
  });
};

var isNull = createContract(function (name, value) {
  return value === null ? value : ValidationError.of(name, value, 'null');
});

var isNumber = createContract(function (name, value) {
  return typeof value === 'number' ? value : ValidationError.of(name, value, 'number');
});

var isBoolean = createContract(function (name, value) {
  return typeof value === 'boolean' ? value : ValidationError.of(name, value, 'boolean');
});

var isObject = function isObject(spec) {
  return createContract(function (valueName, value) {
    if (!value || _typeof(value) !== 'object' || Array.isArray(value)) return ValidationError.of(valueName, value, 'Object');
    var keys = Object.keys(spec);

    for (var index = 0; index < keys.length; index += 1) {
      var keyName = keys[index];
      var contract = spec[keyName];
      var currentValue = value[keyName];
      var result = contract("".concat(valueName, ".").concat(keyName), currentValue);
      if (result instanceof ValidationError) return result;
    }

    return value;
  });
};

var isString = createContract(function (name, value) {
  return typeof value === 'string' ? value : ValidationError.of(name, value, 'string');
});

var isUnion =
/* :: <T> */
function isUnion() {
  for (var _len = arguments.length, contracts = new Array(_len), _key = 0; _key < _len; _key++) {
    contracts[_key] = arguments[_key];
  }

  var unionContract = function unionContract(name, value) {
    var errors = contracts.map(function (contract) {
      return contract(name, value);
    }).reduce(function (scope, error) {
      if (error instanceof ValidationError) scope.push(error);
      return scope;
    }, []);
    if (errors.length !== contracts.length) return value;
    var types = errors.reduce(function (scope, _ref) {
      var expectedTypes = _ref.expectedTypes;

      for (var i = 0; i < expectedTypes.length; i += 1) {
        scope.push(expectedTypes[i]);
      }

      return scope;
    }, []);
    return ValidationError.of.apply(void 0, [name, value].concat(_toConsumableArray(types)));
  };

  return createContract(unionContract);
};

var isVoid = createContract(function (name, value) {
  return value === undefined ? value : ValidationError.of(name, value, 'void');
});
var isUndefined = isVoid;

exports.createContract = createContract;
exports.ValidationError = ValidationError;
exports.isArray = isArray;
exports.isLiteral = isLiteral;
exports.isNull = isNull;
exports.isNumber = isNumber;
exports.isBoolean = isBoolean;
exports.isObject = isObject;
exports.isString = isString;
exports.isUnion = isUnion;
exports.isVoid = isVoid;
exports.isUndefined = isUndefined;
